require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_MCONTEXT_H_)) {
    eval 'sub _AMD64_MCONTEXT_H_ () {1;}' unless defined(&_AMD64_MCONTEXT_H_);
    if(defined(&__x86_64__)) {
	require 'machine/frame_regs.ph';
	eval 'sub GREG_OFFSETS {
	    my($reg, $REG, $idx) = @_;
    	    eval q( &_REG_$REG = $idx,);
	}' unless defined(&GREG_OFFSETS);
	undef(&GREG_OFFSETS) if defined(&GREG_OFFSETS);
	eval 'sub _REG_URSP () { &_REG_RSP;}' unless defined(&_REG_URSP);
	eval 'sub _REG_RFL () { &_REG_RFLAGS;}' unless defined(&_REG_RFL);
	eval 'sub _UC_UCONTEXT_ALIGN () {(~0xf);}' unless defined(&_UC_UCONTEXT_ALIGN);
	eval 'sub _UC_MACHINE_SP {
	    my($uc) = @_;
    	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_RSP]}) - 128));
	}' unless defined(&_UC_MACHINE_SP);
	eval 'sub _UC_MACHINE_FP {
	    my($uc) = @_;
    	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_RBP]})));
	}' unless defined(&_UC_MACHINE_FP);
	eval 'sub _UC_MACHINE_PC {
	    my($uc) = @_;
    	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_RIP]})));
	}' unless defined(&_UC_MACHINE_PC);
	eval 'sub _UC_MACHINE_INTRV {
	    my($uc) = @_;
    	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_RAX]})));
	}' unless defined(&_UC_MACHINE_INTRV);
	eval 'sub _UC_MACHINE_SET_PC {
	    my($uc, $pc) = @_;
    	    eval q( &_UC_MACHINE_PC($uc) = ($pc));
	}' unless defined(&_UC_MACHINE_SET_PC);
	eval 'sub _UC_TLSBASE () {0x80000;}' unless defined(&_UC_TLSBASE);
	eval 'sub _UC_SETSTACK () {0x10000;}' unless defined(&_UC_SETSTACK);
	eval 'sub _UC_CLRSTACK () {0x20000;}' unless defined(&_UC_CLRSTACK);
	eval 'sub __UCONTEXT_SIZE () {784;}' unless defined(&__UCONTEXT_SIZE);
	if(defined(&_RTLD_SOURCE) || defined(&_LIBC_SOURCE) || defined(&__LIBPTHREAD_SOURCE__)) {
	    require 'sys/tls.ph';
	    eval 'sub __lwp_getprivate_fast {
	        my($void) = @_;
    		eval q({ $void * &__tmp;  &__asm  &volatile(\\"movq %%fs:0, %0\\" : \\"=r\\" ( &__tmp));  &__tmp; });
	    }' unless defined(&__lwp_getprivate_fast);
	}
	if(defined(&_KERNEL)) {
	    eval 'sub _NGREG32 () {19;}' unless defined(&_NGREG32);
	    eval 'sub _REG32_GS () {0;}' unless defined(&_REG32_GS);
	    eval 'sub _REG32_FS () {1;}' unless defined(&_REG32_FS);
	    eval 'sub _REG32_ES () {2;}' unless defined(&_REG32_ES);
	    eval 'sub _REG32_DS () {3;}' unless defined(&_REG32_DS);
	    eval 'sub _REG32_EDI () {4;}' unless defined(&_REG32_EDI);
	    eval 'sub _REG32_ESI () {5;}' unless defined(&_REG32_ESI);
	    eval 'sub _REG32_EBP () {6;}' unless defined(&_REG32_EBP);
	    eval 'sub _REG32_ESP () {7;}' unless defined(&_REG32_ESP);
	    eval 'sub _REG32_EBX () {8;}' unless defined(&_REG32_EBX);
	    eval 'sub _REG32_EDX () {9;}' unless defined(&_REG32_EDX);
	    eval 'sub _REG32_ECX () {10;}' unless defined(&_REG32_ECX);
	    eval 'sub _REG32_EAX () {11;}' unless defined(&_REG32_EAX);
	    eval 'sub _REG32_TRAPNO () {12;}' unless defined(&_REG32_TRAPNO);
	    eval 'sub _REG32_ERR () {13;}' unless defined(&_REG32_ERR);
	    eval 'sub _REG32_EIP () {14;}' unless defined(&_REG32_EIP);
	    eval 'sub _REG32_CS () {15;}' unless defined(&_REG32_CS);
	    eval 'sub _REG32_EFL () {16;}' unless defined(&_REG32_EFL);
	    eval 'sub _REG32_UESP () {17;}' unless defined(&_REG32_UESP);
	    eval 'sub _REG32_SS () {18;}' unless defined(&_REG32_SS);
	    eval 'sub _UC_MACHINE32_SP {
	        my($uc) = @_;
    		eval q((($uc)-> ($uc_mcontext->{__gregs[_REG32_UESP]})));
	    }' unless defined(&_UC_MACHINE32_SP);
	    eval 'sub _UC_FXSAVE () {0x20;}' unless defined(&_UC_FXSAVE);
	    eval 'sub _UC_MACHINE32_PAD () {4;}' unless defined(&_UC_MACHINE32_PAD);
	    eval 'sub __UCONTEXT32_SIZE () {776;}' unless defined(&__UCONTEXT32_SIZE);
	}
    } else {
	require 'i386/mcontext.ph';
    }
}
1;
