require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_64_VMPARAM_H_)) {
    eval 'sub _X86_64_VMPARAM_H_ () {1;}' unless defined(&_X86_64_VMPARAM_H_);
    if(defined(&__x86_64__)) {
	require 'sys/mutex.ph';
	if(defined(&_KERNEL_OPT)) {
	    require './amd64/opt_xen.ph';
	}
	eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
	eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
	eval 'sub PAGE_MASK () {( &PAGE_SIZE - 1);}' unless defined(&PAGE_MASK);
	eval 'sub PAGER_MAP_DEFAULT_SIZE () {(512* 1024* 1024);}' unless defined(&PAGER_MAP_DEFAULT_SIZE);
	unless(defined(&UBC_WINSHIFT)) {
	    eval 'sub UBC_WINSHIFT () {16;}' unless defined(&UBC_WINSHIFT);
	}
	unless(defined(&UBC_NWINS)) {
	    eval 'sub UBC_NWINS () {4096;}' unless defined(&UBC_NWINS);
	}
	eval 'sub USRSTACK () { &VM_MAXUSER_ADDRESS;}' unless defined(&USRSTACK);
	eval 'sub USRSTACK32 () { &VM_MAXUSER_ADDRESS32;}' unless defined(&USRSTACK32);
	eval 'sub MAXTSIZ () {(8*1024*1024*1024);}' unless defined(&MAXTSIZ);
	unless(defined(&DFLDSIZ)) {
	    eval 'sub DFLDSIZ () {(256*1024*1024);}' unless defined(&DFLDSIZ);
	}
	unless(defined(&MAXDSIZ)) {
	    eval 'sub MAXDSIZ () {(8*1024*1024*1024);}' unless defined(&MAXDSIZ);
	}
	unless(defined(&DFLSSIZ)) {
	    eval 'sub DFLSSIZ () {(4*1024*1024);}' unless defined(&DFLSSIZ);
	}
	unless(defined(&MAXSSIZ)) {
	    eval 'sub MAXSSIZ () {(128*1024*1024);}' unless defined(&MAXSSIZ);
	}
	unless(defined(&DFLDSIZ32)) {
	    eval 'sub DFLDSIZ32 () {(256*1024*1024);}' unless defined(&DFLDSIZ32);
	}
	unless(defined(&MAXDSIZ32)) {
	    eval 'sub MAXDSIZ32 () {(3*1024*1024*1024);}' unless defined(&MAXDSIZ32);
	}
	unless(defined(&DFLSSIZ32)) {
	    eval 'sub DFLSSIZ32 () {(2*1024*1024);}' unless defined(&DFLSSIZ32);
	}
	unless(defined(&MAXSSIZ32)) {
	    eval 'sub MAXSSIZ32 () {(64*1024*1024);}' unless defined(&MAXSSIZ32);
	}
	eval 'sub USRIOSIZE () {300;}' unless defined(&USRIOSIZE);
	eval 'sub VM_MIN_ADDRESS () {0;}' unless defined(&VM_MIN_ADDRESS);
	eval 'sub VM_MAXUSER_ADDRESS () {(0x7f8000000000 -  &PAGE_SIZE);}' unless defined(&VM_MAXUSER_ADDRESS);
	eval 'sub VM_MAXUSER_ADDRESS32 () {0xfffff000;}' unless defined(&VM_MAXUSER_ADDRESS32);
	eval 'sub VM_MAX_ADDRESS () {0x7fbfdfeff000;}' unless defined(&VM_MAX_ADDRESS);
	unless(defined(&XENPV)) {
	    eval 'sub VM_MIN_KERNEL_ADDRESS_DEFAULT () {0xffff800000000000;}' unless defined(&VM_MIN_KERNEL_ADDRESS_DEFAULT);
	    eval 'sub VM_MAX_KERNEL_ADDRESS_DEFAULT () {0xffffa00000000000;}' unless defined(&VM_MAX_KERNEL_ADDRESS_DEFAULT);
	} else {
	    eval 'sub VM_MIN_KERNEL_ADDRESS_DEFAULT () {0xffffa00000000000;}' unless defined(&VM_MIN_KERNEL_ADDRESS_DEFAULT);
	    eval 'sub VM_MAX_KERNEL_ADDRESS_DEFAULT () {0xffffc00000000000;}' unless defined(&VM_MAX_KERNEL_ADDRESS_DEFAULT);
	}
	if(defined(&_KMEMUSER) || defined(&_KERNEL)) {
	    eval 'sub VM_MIN_KERNEL_ADDRESS () { &vm_min_kernel_address;}' unless defined(&VM_MIN_KERNEL_ADDRESS);
	    eval 'sub VM_MAX_KERNEL_ADDRESS () { &vm_max_kernel_address;}' unless defined(&VM_MAX_KERNEL_ADDRESS);
	}
	eval 'sub PDP_SIZE () {1;}' unless defined(&PDP_SIZE);
	if(defined(&_KERNEL_OPT)) {
	    require './amd64/opt_uvm.ph';
	}
	eval 'sub __USE_TOPDOWN_VM () {1;}' unless defined(&__USE_TOPDOWN_VM);
	eval 'sub VM_DEFAULT_ADDRESS_BOTTOMUP {
	    my($da, $sz) = @_;
    	    eval q( &round_page(( &vaddr_t)($da) + ( &vsize_t) &maxdmap));
	}' unless defined(&VM_DEFAULT_ADDRESS_BOTTOMUP);
	eval 'sub VM_DEFAULT_ADDRESS32_TOPDOWN {
	    my($da, $sz) = @_;
    	    eval q( &trunc_page( &USRSTACK32 -  &MAXSSIZ32 - ($sz) -  &user_stack_guard_size));
	}' unless defined(&VM_DEFAULT_ADDRESS32_TOPDOWN);
	eval 'sub VM_DEFAULT_ADDRESS32_BOTTOMUP {
	    my($da, $sz) = @_;
    	    eval q( &round_page(( &vaddr_t)($da) + ( &vsize_t) &MAXDSIZ32));
	}' unless defined(&VM_DEFAULT_ADDRESS32_BOTTOMUP);
	eval 'sub VM_PHYS_SIZE () {( &USRIOSIZE* &PAGE_SIZE);}' unless defined(&VM_PHYS_SIZE);
	eval 'sub VM_PHYSSEG_MAX () {64;}' unless defined(&VM_PHYSSEG_MAX);
	eval 'sub VM_PHYSSEG_STRAT () { &VM_PSTRAT_BIGFIRST;}' unless defined(&VM_PHYSSEG_STRAT);
	eval 'sub VM_NFREELIST () {6;}' unless defined(&VM_NFREELIST);
	eval 'sub VM_FREELIST_DEFAULT () {0;}' unless defined(&VM_FREELIST_DEFAULT);
	eval 'sub VM_FREELIST_FIRST1T () {1;}' unless defined(&VM_FREELIST_FIRST1T);
	eval 'sub VM_FREELIST_FIRST64G () {2;}' unless defined(&VM_FREELIST_FIRST64G);
	eval 'sub VM_FREELIST_FIRST4G () {3;}' unless defined(&VM_FREELIST_FIRST4G);
	eval 'sub VM_FREELIST_FIRST1G () {4;}' unless defined(&VM_FREELIST_FIRST1G);
	eval 'sub VM_FREELIST_FIRST16 () {5;}' unless defined(&VM_FREELIST_FIRST16);
    } else {
	require 'i386/vmparam.ph';
    }
}
1;
