require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512bf16vlintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512BF16VLINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512BF16VLINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512BF16VLINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VL__) || !defined(&__AVX512BF16__)) {
	eval 'sub __DISABLE_AVX512BF16VL__ () {1;}' unless defined(&__DISABLE_AVX512BF16VL__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtne2ps_pbh ( &__m256bh  &__A,  &__mmask16  &__B,  &__m256  &__C,  &__m256  &__D) { ( &__m256bh) &__builtin_ia32_cvtne2ps2bf16_v16hi_mask( &__C,  &__D,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtne2ps_pbh ( &__mmask16  &__A,  &__m256  &__B,  &__m256  &__C) { ( &__m256bh) &__builtin_ia32_cvtne2ps2bf16_v16hi_maskz( &__B,  &__C,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtne2ps_pbh ( &__m128  &__A,  &__m128  &__B) { ( &__m128bh) &__builtin_ia32_cvtne2ps2bf16_v8hi( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtne2ps_pbh ( &__m128bh  &__A,  &__mmask8  &__B,  &__m128  &__C,  &__m128  &__D) { ( &__m128bh) &__builtin_ia32_cvtne2ps2bf16_v8hi_mask( &__C,  &__D,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtne2ps_pbh ( &__mmask8  &__A,  &__m128  &__B,  &__m128  &__C) { ( &__m128bh) &__builtin_ia32_cvtne2ps2bf16_v8hi_maskz( &__B,  &__C,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_cvtneps_pbh ( &__m128bh  &__A,  &__mmask8  &__B,  &__m256  &__C) { ( &__m128bh) &__builtin_ia32_cvtneps2bf16_v8sf_mask( &__C,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_cvtneps_pbh ( &__mmask8  &__A,  &__m256  &__B) { ( &__m128bh) &__builtin_ia32_cvtneps2bf16_v8sf_maskz( &__B,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtneps_pbh ( &__m128  &__A) { ( &__m128bh) &__builtin_ia32_cvtneps2bf16_v4sf( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_cvtneps_pbh ( &__m128bh  &__A,  &__mmask8  &__B,  &__m128  &__C) { ( &__m128bh) &__builtin_ia32_cvtneps2bf16_v4sf_mask( &__C,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_cvtneps_pbh ( &__mmask8  &__A,  &__m128  &__B) { ( &__m128bh) &__builtin_ia32_cvtneps2bf16_v4sf_maskz( &__B,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_dpbf16_ps ( &__m256  &__A,  &__mmask8  &__B,  &__m256bh  &__C,  &__m256bh  &__D) { ( &__m256) &__builtin_ia32_dpbf16ps_v8sf_mask( &__A,  &__C,  &__D,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_dpbf16_ps ( &__mmask8  &__A,  &__m256  &__B,  &__m256bh  &__C,  &__m256bh  &__D) { ( &__m256) &__builtin_ia32_dpbf16ps_v8sf_maskz( &__B,  &__C,  &__D,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dpbf16_ps ( &__m128  &__A,  &__m128bh  &__B,  &__m128bh  &__C) { ( &__m128) &__builtin_ia32_dpbf16ps_v4sf( &__A,  &__B,  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_dpbf16_ps ( &__m128  &__A,  &__mmask8  &__B,  &__m128bh  &__C,  &__m128bh  &__D) { ( &__m128) &__builtin_ia32_dpbf16ps_v4sf_mask( &__A,  &__C,  &__D,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_dpbf16_ps ( &__mmask8  &__A,  &__m128  &__B,  &__m128bh  &__C,  &__m128bh  &__D) { ( &__m128) &__builtin_ia32_dpbf16ps_v4sf_maskz( &__B,  &__C,  &__D,  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512BF16VL__)) {
	undef(&__DISABLE_AVX512BF16VL__) if defined(&__DISABLE_AVX512BF16VL__);
    }
}
1;
