require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <rtmintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_RTMINTRIN_H_INCLUDED)) {
    eval 'sub _RTMINTRIN_H_INCLUDED () {1;}' unless defined(&_RTMINTRIN_H_INCLUDED);
    unless(defined(&__RTM__)) {
	eval 'sub __DISABLE_RTM__ () {1;}' unless defined(&__DISABLE_RTM__);
    }
    eval 'sub _XBEGIN_STARTED () {(~0);}' unless defined(&_XBEGIN_STARTED);
    eval 'sub _XABORT_EXPLICIT () {(1<< 0);}' unless defined(&_XABORT_EXPLICIT);
    eval 'sub _XABORT_RETRY () {(1<< 1);}' unless defined(&_XABORT_RETRY);
    eval 'sub _XABORT_CONFLICT () {(1<< 2);}' unless defined(&_XABORT_CONFLICT);
    eval 'sub _XABORT_CAPACITY () {(1<< 3);}' unless defined(&_XABORT_CAPACITY);
    eval 'sub _XABORT_DEBUG () {(1<< 4);}' unless defined(&_XABORT_DEBUG);
    eval 'sub _XABORT_NESTED () {(1<< 5);}' unless defined(&_XABORT_NESTED);
    eval 'sub _XABORT_CODE {
        my($x) = @_;
	    eval q(((($x) >> 24) & 0xff));
    }' unless defined(&_XABORT_CODE);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xabort ( &const my $__imm) {  &__builtin_ia32_xabort ( $__imm); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _xabort {
	    my($N) = @_;
    	    eval q( &__builtin_ia32_xabort ($N));
	}' unless defined(&_xabort);
    }
    if(defined(&__DISABLE_RTM__)) {
	undef(&__DISABLE_RTM__) if defined(&__DISABLE_RTM__);
    }
}
1;
