require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PTE_H_)) {
    eval 'sub _I386_PTE_H_ () {1;}' unless defined(&_I386_PTE_H_);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_xen.ph';
    }
    if(!defined(&_LOCORE)) {
	require 'sys/stdint.ph';
	if(defined(&PAE)) {
	} else {
	}
    }
    eval 'sub VA_SIGN_MASK () {0;}' unless defined(&VA_SIGN_MASK);
    eval 'sub VA_SIGN_NEG {
        my($va) = @_;
	    eval q((($va) |  &VA_SIGN_MASK));
    }' unless defined(&VA_SIGN_NEG);
    eval 'sub VA_SIGN_POS {
        my($va) = @_;
	    eval q((($va) & ~ &VA_SIGN_MASK));
    }' unless defined(&VA_SIGN_POS);
    if(defined(&PAE)) {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {21;}' unless defined(&L2_SHIFT);
	eval 'sub L3_SHIFT () {30;}' unless defined(&L3_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub NBPD_L3 () {(1 <<  &L3_SHIFT);}' unless defined(&NBPD_L3);
	eval 'sub L3_MASK () {0xc0000000;}' unless defined(&L3_MASK);
	eval 'sub L2_REALMASK () {0x3fe00000;}' unless defined(&L2_REALMASK);
	eval 'sub L2_MASK () {( &L2_REALMASK |  &L3_MASK);}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x1ff000;}' unless defined(&L1_MASK);
	eval 'sub L3_FRAME () {( &L3_MASK);}' unless defined(&L3_FRAME);
	eval 'sub L2_FRAME () {( &L3_FRAME |  &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PTE_4KFRAME () {0xffffffffff000;}' unless defined(&PTE_4KFRAME);
	eval 'sub PTE_2MFRAME () {0xfffffffe00000;}' unless defined(&PTE_2MFRAME);
	eval 'sub PTE_FRAME () { &PTE_4KFRAME;}' unless defined(&PTE_FRAME);
	eval 'sub PTE_LGFRAME () { &PTE_2MFRAME;}' unless defined(&PTE_LGFRAME);
	eval 'sub l2tol3 {
	    my($idx) = @_;
    	    eval q((($idx) >> ( &L3_SHIFT -  &L2_SHIFT)));
	}' unless defined(&l2tol3);
	eval 'sub l2tol2 {
	    my($idx) = @_;
    	    eval q((($idx) & ( &L2_REALMASK >>  &L2_SHIFT)));
	}' unless defined(&l2tol2);
    } else {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {22;}' unless defined(&L2_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub L2_MASK () {0xffc00000;}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x3ff000;}' unless defined(&L1_MASK);
	eval 'sub L2_FRAME () {( &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PTE_4KFRAME () {0xfffff000;}' unless defined(&PTE_4KFRAME);
	eval 'sub PTE_4MFRAME () {0xffc00000;}' unless defined(&PTE_4MFRAME);
	eval 'sub PTE_FRAME () { &PTE_4KFRAME;}' unless defined(&PTE_FRAME);
	eval 'sub PTE_LGFRAME () { &PTE_4MFRAME;}' unless defined(&PTE_LGFRAME);
    }
    eval 'sub PTE_P () {0x1;}' unless defined(&PTE_P);
    eval 'sub PTE_W () {0x2;}' unless defined(&PTE_W);
    eval 'sub PTE_U () {0x4;}' unless defined(&PTE_U);
    eval 'sub PTE_PWT () {0x8;}' unless defined(&PTE_PWT);
    eval 'sub PTE_PCD () {0x10;}' unless defined(&PTE_PCD);
    eval 'sub PTE_A () {0x20;}' unless defined(&PTE_A);
    eval 'sub PTE_D () {0x40;}' unless defined(&PTE_D);
    eval 'sub PTE_PAT () {0x80;}' unless defined(&PTE_PAT);
    eval 'sub PTE_PS () {0x80;}' unless defined(&PTE_PS);
    eval 'sub PTE_G () {0x100;}' unless defined(&PTE_G);
    eval 'sub PTE_AVL1 () {0x200;}' unless defined(&PTE_AVL1);
    eval 'sub PTE_AVL2 () {0x400;}' unless defined(&PTE_AVL2);
    eval 'sub PTE_AVL3 () {0x800;}' unless defined(&PTE_AVL3);
    eval 'sub PTE_LGPAT () {0x1000;}' unless defined(&PTE_LGPAT);
    if(defined(&PAE)) {
	eval 'sub PTE_NX () {0x8000000000000000;}' unless defined(&PTE_NX);
    } else {
	eval 'sub PTE_NX () {0;}' unless defined(&PTE_NX);
    }
    eval 'sub _MACHINE_PTE_H_X86 () {1;}' unless defined(&_MACHINE_PTE_H_X86);
    require 'x86/pte.ph';
    undef(&_MACHINE_PTE_H_X86) if defined(&_MACHINE_PTE_H_X86);
}
1;
