require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_CPU_H_)) {
    eval 'sub _X86_CPU_H_ () {1;}' unless defined(&_X86_CPU_H_);
    if(defined(&_KERNEL) || defined(&_STANDALONE)) {
	require 'sys/types.ph';
    } else {
	require 'stdint.ph';
	require 'stdbool.ph';
    }
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	if(defined(&_KERNEL_OPT)) {
	    require './x86/opt_xen.ph';
	    require './x86/opt_svs.ph';
	}
	require 'machine/frame.ph';
	require 'machine/pte.ph';
	require 'machine/segments.ph';
	require 'machine/tss.ph';
	require 'machine/intrdefs.ph';
	require 'x86/cacheinfo.ph';
	require 'sys/cpu_data.ph';
	require 'sys/evcnt.ph';
	require 'sys/device_if.ph';
	if(defined(&SVS)) {
	    require 'sys/mutex.ph';
	}
	if(defined(&XEN)) {
	    require 'xen/include/public/xen.ph';
	    require 'xen/include/public/event_channel.ph';
	    require 'sys/mutex.ph';
	}
	if(defined(&__x86_64__)) {
	    eval 'sub i386tss () { &x86_64_tss;}' unless defined(&i386tss);
	}
	eval 'sub NIOPORTS () {1024;}' unless defined(&NIOPORTS);
	eval 'sub IOMAPSIZE () {( &NIOPORTS / 8);}' unless defined(&IOMAPSIZE);
	if(defined(&i386)) {
	}
	eval 'sub TLBSTATE_VALID () {0;}' unless defined(&TLBSTATE_VALID);
	eval 'sub TLBSTATE_LAZY () {1;}' unless defined(&TLBSTATE_LAZY);
	eval 'sub TLBSTATE_STALE () {2;}' unless defined(&TLBSTATE_STALE);
	unless(defined(&__HAVE_DIRECT_MAP)) {
	    eval 'sub VPAGE_SRC () {0;}' unless defined(&VPAGE_SRC);
	    eval 'sub VPAGE_DST () {1;}' unless defined(&VPAGE_DST);
	    eval 'sub VPAGE_ZER () {2;}' unless defined(&VPAGE_ZER);
	    eval 'sub VPAGE_PTP () {3;}' unless defined(&VPAGE_PTP);
	    eval 'sub VPAGE_MAX () {4;}' unless defined(&VPAGE_MAX);
	}
	if(defined(&PAE)) {
	}
	if(defined(&SVS)) {
	}
	unless(defined(&XENPV)) {
	} else {
	}
	if(defined(&XEN)) {
	    if(defined(&XENPV)) {
		if(defined(&PAE) || defined(&__x86_64__)) {
		}
		if(defined(&__x86_64__)) {
		}
	    }
	}
	if(defined(&GPROF)  && defined(&MULTIPROCESSOR)) {
	}
	if(defined(&XEN)  && !defined(&XENPV)) {
	}
	if(defined(&__x86_64__)) {
	    eval 'sub X86_TF_RAX {
	        my($tf) = @_;
    		eval q( ($tf->{tf_rax}));
	    }' unless defined(&X86_TF_RAX);
	    eval 'sub X86_TF_RDX {
	        my($tf) = @_;
    		eval q( ($tf->{tf_rdx}));
	    }' unless defined(&X86_TF_RDX);
	    eval 'sub X86_TF_RSP {
	        my($tf) = @_;
    		eval q( ($tf->{tf_rsp}));
	    }' unless defined(&X86_TF_RSP);
	    eval 'sub X86_TF_RIP {
	        my($tf) = @_;
    		eval q( ($tf->{tf_rip}));
	    }' unless defined(&X86_TF_RIP);
	    eval 'sub X86_TF_RFLAGS {
	        my($tf) = @_;
    		eval q( ($tf->{tf_rflags}));
	    }' unless defined(&X86_TF_RFLAGS);
	} else {
	    eval 'sub X86_TF_RAX {
	        my($tf) = @_;
    		eval q( ($tf->{tf_eax}));
	    }' unless defined(&X86_TF_RAX);
	    eval 'sub X86_TF_RDX {
	        my($tf) = @_;
    		eval q( ($tf->{tf_edx}));
	    }' unless defined(&X86_TF_RDX);
	    eval 'sub X86_TF_RSP {
	        my($tf) = @_;
    		eval q( ($tf->{tf_esp}));
	    }' unless defined(&X86_TF_RSP);
	    eval 'sub X86_TF_RIP {
	        my($tf) = @_;
    		eval q( ($tf->{tf_eip}));
	    }' unless defined(&X86_TF_RIP);
	    eval 'sub X86_TF_RFLAGS {
	        my($tf) = @_;
    		eval q( ($tf->{tf_eflags}));
	    }' unless defined(&X86_TF_RFLAGS);
	}
	eval 'sub CPUF_BSP () {0x1;}' unless defined(&CPUF_BSP);
	eval 'sub CPUF_AP () {0x2;}' unless defined(&CPUF_AP);
	eval 'sub CPUF_SP () {0x4;}' unless defined(&CPUF_SP);
	eval 'sub CPUF_PRIMARY () {0x8;}' unless defined(&CPUF_PRIMARY);
	eval 'sub CPUF_SYNCTSC () {0x800;}' unless defined(&CPUF_SYNCTSC);
	eval 'sub CPUF_PRESENT () {0x1000;}' unless defined(&CPUF_PRESENT);
	eval 'sub CPUF_RUNNING () {0x2000;}' unless defined(&CPUF_RUNNING);
	eval 'sub CPUF_PAUSE () {0x4000;}' unless defined(&CPUF_PAUSE);
	eval 'sub CPUF_GO () {0x8000;}' unless defined(&CPUF_GO);
    }
    if(defined(&_KERNEL)) {
	eval 'sub CPU_INFO_ITERATOR () {\'int\'  &__unused;}' unless defined(&CPU_INFO_ITERATOR);
	eval 'sub CPU_INFO_FOREACH {
	    my($cii, $ci) = @_;
    	    eval q($ci =  &cpu_info_list; $ci !=  &NULL; $ci =  ($ci->{ci_next}));
	}' unless defined(&CPU_INFO_FOREACH);
	eval 'sub CPU_STARTUP {
	    my($_ci, $_target) = @_;
    	    eval q((($_ci)-> ($ci_func->{start})($_ci, $_target)));
	}' unless defined(&CPU_STARTUP);
	eval 'sub CPU_STOP {
	    my($_ci) = @_;
    	    eval q((($_ci)-> ($ci_func->{stop})($_ci)));
	}' unless defined(&CPU_STOP);
	eval 'sub CPU_START_CLEANUP {
	    my($_ci) = @_;
    	    eval q((($_ci)-> ($ci_func->{cleanup})($_ci)));
	}' unless defined(&CPU_START_CLEANUP);
	if(!defined(&__GNUC__) || defined(&_MODULE)) {
	    if(defined(&__GNUC__)) {
	    } else {
	    }
	}
	eval 'sub cpu_number () {
	    eval q(( &cpu_index( &curcpu())));
	}' unless defined(&cpu_number);
	eval 'sub CPU_IS_PRIMARY {
	    my($ci) = @_;
    	    eval q((($ci)-> &ci_flags &  &CPUF_PRIMARY));
	}' unless defined(&CPU_IS_PRIMARY);
	eval 'sub aston {
	    my($l) = @_;
    	    eval q((($l)-> ($l_md->{md_astpending}) = 1));
	}' unless defined(&aston);
	eval 'sub curcpu () {
	    eval q( &x86_curcpu());
	}' unless defined(&curcpu);
	eval 'sub curlwp () { &x86_curlwp();}' unless defined(&curlwp);
	eval 'sub curpcb () {( &lwp_getpcb( &curlwp));}' unless defined(&curpcb);
	unless(defined(&__HIDE_DELAY)) {
	    eval 'sub DELAY {
	        my($x) = @_;
    		eval q((* &delay_func)($x));
	    }' unless defined(&DELAY);
	    eval 'sub delay {
	        my($x) = @_;
    		eval q((* &delay_func)($x));
	    }' unless defined(&delay);
	}
	if(defined(&__i386__)) {
	    eval 'sub i386_fpu_present () {1;}' unless defined(&i386_fpu_present);
	} else {
	    eval 'sub i386_fpu_present () {1;}' unless defined(&i386_fpu_present);
	    eval 'sub i386_fpu_fdivbug () {0;}' unless defined(&i386_fpu_fdivbug);
	    eval 'sub i386_use_fxsave () {1;}' unless defined(&i386_use_fxsave);
	    eval 'sub i386_has_sse () {1;}' unless defined(&i386_has_sse);
	    eval 'sub i386_has_sse2 () {1;}' unless defined(&i386_has_sse2);
	}
	eval 'sub FPU_SAVE_FSAVE () {0;}' unless defined(&FPU_SAVE_FSAVE);
	eval 'sub FPU_SAVE_FXSAVE () {1;}' unless defined(&FPU_SAVE_FXSAVE);
	eval 'sub FPU_SAVE_XSAVE () {2;}' unless defined(&FPU_SAVE_XSAVE);
	eval 'sub FPU_SAVE_XSAVEOPT () {3;}' unless defined(&FPU_SAVE_XSAVEOPT);
	eval 'sub cpu_idle () {
	    eval q((* &x86_cpu_idle)());
	}' unless defined(&cpu_idle);
	if(defined(&i386)) {
	}
	eval("sub VM_GUEST_NO () { 0; }") unless defined(&VM_GUEST_NO);
	eval("sub VM_GUEST_VM () { 1; }") unless defined(&VM_GUEST_VM);
	eval("sub VM_GUEST_XENPV () { 2; }") unless defined(&VM_GUEST_XENPV);
	eval("sub VM_GUEST_XENPVH () { 3; }") unless defined(&VM_GUEST_XENPVH);
	eval("sub VM_GUEST_XENHVM () { 4; }") unless defined(&VM_GUEST_XENHVM);
	eval("sub VM_GUEST_XENPVHVM () { 5; }") unless defined(&VM_GUEST_XENPVHVM);
	eval("sub VM_GUEST_HV () { 6; }") unless defined(&VM_GUEST_HV);
	eval("sub VM_GUEST_VMWARE () { 7; }") unless defined(&VM_GUEST_VMWARE);
	eval("sub VM_GUEST_KVM () { 8; }") unless defined(&VM_GUEST_KVM);
	eval("sub VM_GUEST_VIRTUALBOX () { 9; }") unless defined(&VM_GUEST_VIRTUALBOX);
	eval("sub VM_LAST () { 10; }") unless defined(&VM_LAST);
	eval 'sub vm_guest_is_xenpv {
	    my($void) = @_;
    	    eval q({  &switch( &vm_guest) {  &case  &VM_GUEST_XENPV:  &case  &VM_GUEST_XENPVH:  &case  &VM_GUEST_XENPVHVM:  &true;  &default:  &false; } });
	}' unless defined(&vm_guest_is_xenpv);
	eval 'sub vm_guest_is_xenpvh_or_pvhvm {
	    my($void) = @_;
    	    eval q({  &switch( &vm_guest) {  &case  &VM_GUEST_XENPVH:  &case  &VM_GUEST_XENPVHVM:  &true;  &default:  &false; } });
	}' unless defined(&vm_guest_is_xenpvh_or_pvhvm);
	if(defined(&XENPV)) {
	}
	if(defined(&XEN)) {
	}
    }
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	require 'machine/psl.ph';
    }
    eval 'sub CPU_CONSDEV () {1;}' unless defined(&CPU_CONSDEV);
    eval 'sub CPU_BIOSBASEMEM () {2;}' unless defined(&CPU_BIOSBASEMEM);
    eval 'sub CPU_BIOSEXTMEM () {3;}' unless defined(&CPU_BIOSEXTMEM);
    eval 'sub CPU_BOOTED_KERNEL () {5;}' unless defined(&CPU_BOOTED_KERNEL);
    eval 'sub CPU_DISKINFO () {6;}' unless defined(&CPU_DISKINFO);
    eval 'sub CPU_FPU_PRESENT () {7;}' unless defined(&CPU_FPU_PRESENT);
    eval 'sub CPU_OSFXSR () {8;}' unless defined(&CPU_OSFXSR);
    eval 'sub CPU_SSE () {9;}' unless defined(&CPU_SSE);
    eval 'sub CPU_SSE2 () {10;}' unless defined(&CPU_SSE2);
    eval 'sub CPU_TMLR_MODE () {11;}' unless defined(&CPU_TMLR_MODE);
    eval 'sub CPU_TMLR_FREQUENCY () {12;}' unless defined(&CPU_TMLR_FREQUENCY);
    eval 'sub CPU_TMLR_VOLTAGE () {13;}' unless defined(&CPU_TMLR_VOLTAGE);
    eval 'sub CPU_TMLR_PERCENTAGE () {14;}' unless defined(&CPU_TMLR_PERCENTAGE);
    eval 'sub CPU_FPU_SAVE () {15;}' unless defined(&CPU_FPU_SAVE);
    eval 'sub CPU_FPU_SAVE_SIZE () {16;}' unless defined(&CPU_FPU_SAVE_SIZE);
    eval 'sub CPU_XSAVE_FEATURES () {17;}' unless defined(&CPU_XSAVE_FEATURES);
    eval 'sub MAX_BIOSDISKS () {16;}' unless defined(&MAX_BIOSDISKS);
    eval 'sub BIFLAG_INVALID () {0x1;}' unless defined(&BIFLAG_INVALID);
    eval 'sub BIFLAG_EXTINT13 () {0x2;}' unless defined(&BIFLAG_EXTINT13);
}
1;
