require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_PMAP_H_)) {
    eval 'sub _X86_PMAP_H_ () {1;}' unless defined(&_X86_PMAP_H_);
    if(defined(&_KERNEL)) {
	require 'x86/pmap_pv.ph';
	require 'uvm/pmap/pmap_pvt.ph';
	eval 'sub pmap_clear_modify {
	    my($pg) = @_;
    	    eval q( &pmap_clear_attrs($pg,  &PP_ATTRS_D));
	}' unless defined(&pmap_clear_modify);
	eval 'sub pmap_clear_reference {
	    my($pg) = @_;
    	    eval q( &pmap_clear_attrs($pg,  &PP_ATTRS_A));
	}' unless defined(&pmap_clear_reference);
	eval 'sub pmap_copy {
	    my($DP,$SP,$D,$L,$S) = @_;
    	    eval q( &__USE($L));
	}' unless defined(&pmap_copy);
	eval 'sub pmap_is_modified {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PP_ATTRS_D));
	}' unless defined(&pmap_is_modified);
	eval 'sub pmap_is_referenced {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PP_ATTRS_A));
	}' unless defined(&pmap_is_referenced);
	eval 'sub pmap_move {
	    my($DP,$SP,$D,$L,$S) = @_;
    	    eval q();
	}' unless defined(&pmap_move);
	eval 'sub pmap_phys_address {
	    my($ppn) = @_;
    	    eval q(( &x86_ptob($ppn) & ~ &X86_MMAP_FLAG_MASK));
	}' unless defined(&pmap_phys_address);
	eval 'sub pmap_mmap_flags {
	    my($ppn) = @_;
    	    eval q( &x86_mmap_flags($ppn));
	}' unless defined(&pmap_mmap_flags);
	if(defined(&__x86_64__) || defined(&PAE)) {
	    eval 'sub X86_MMAP_FLAG_SHIFT () {(64-  &PGSHIFT);}' unless defined(&X86_MMAP_FLAG_SHIFT);
	} else {
	    eval 'sub X86_MMAP_FLAG_SHIFT () {(32-  &PGSHIFT);}' unless defined(&X86_MMAP_FLAG_SHIFT);
	}
	eval 'sub X86_MMAP_FLAG_MASK () {0xf;}' unless defined(&X86_MMAP_FLAG_MASK);
	eval 'sub X86_MMAP_FLAG_PREFETCH () {0x1;}' unless defined(&X86_MMAP_FLAG_PREFETCH);
	eval 'sub __HAVE_PMAP_PV_TRACK () {1;}' unless defined(&__HAVE_PMAP_PV_TRACK);
	eval 'sub PMAP_GROWKERNEL () {1;}' unless defined(&PMAP_GROWKERNEL);
	eval 'sub PMAP_FORK () {1;}' unless defined(&PMAP_FORK);
	eval 'sub POOL_VTOPHYS {
	    my($va) = @_;
    	    eval q( &vtophys(( &vaddr_t) ($va)));
	}' unless defined(&POOL_VTOPHYS);
	if(defined(&__HAVE_DIRECT_MAP)) {
	    eval 'sub PMAP_DIRECT_BASE () { &pmap_direct_base;}' unless defined(&PMAP_DIRECT_BASE);
	    eval 'sub PMAP_DIRECT_END () { &pmap_direct_end;}' unless defined(&PMAP_DIRECT_END);
	    eval 'sub PMAP_DIRECT_MAP {
	        my($pa) = @_;
    		eval q((( &vaddr_t) &PMAP_DIRECT_BASE + ($pa)));
	    }' unless defined(&PMAP_DIRECT_MAP);
	    eval 'sub PMAP_DIRECT_UNMAP {
	        my($va) = @_;
    		eval q((( &paddr_t)($va) -  &PMAP_DIRECT_BASE));
	    }' unless defined(&PMAP_DIRECT_UNMAP);
	    eval 'sub PMAP_MAP_POOLPAGE {
	        my($pa) = @_;
    		eval q( &PMAP_DIRECT_MAP(($pa)));
	    }' unless defined(&PMAP_MAP_POOLPAGE);
	    eval 'sub PMAP_UNMAP_POOLPAGE {
	        my($va) = @_;
    		eval q( &PMAP_DIRECT_UNMAP(($va)));
	    }' unless defined(&PMAP_UNMAP_POOLPAGE);
	}
	eval 'sub __HAVE_VM_PAGE_MD () {1;}' unless defined(&__HAVE_VM_PAGE_MD);
	eval 'sub VM_MDPAGE_INIT {
	    my($pg) = @_;
    	    eval q( &memset(($pg)-> &mdpage, 0, $sizeof{($pg)-> &mdpage});  &PMAP_PAGE_INIT(($pg)-> ($mdpage->{mp_pp})));
	}' unless defined(&VM_MDPAGE_INIT);
    }
}
1;
